## open5gs 2.0.16

=== debian/changelog ===
open5gs (2.0.16) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Wed, 07 Oct 2020 21:31:32 -0400

open5gs (2.0.16~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Wed, 07 Oct 2020 21:30:17 -0400

open5gs (2.0.16~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Wed, 07 Oct 2020 21:28:04 -0400

open5gs (2.0.15) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 05 Oct 2020 14:10:57 -0400

open5gs (2.0.15~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 05 Oct 2020 14:09:37 -0400

open5gs (2.0.15~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 05 Oct 2020 14:08:21 -0400

open5gs (2.0.13) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sat, 03 Oct 2020 22:44:15 -0400

open5gs (2.0.13~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sat, 03 Oct 2020 22:42:55 -0400

open5gs (2.0.13~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sat, 03 Oct 2020 22:41:30 -0400

open5gs (2.0.12) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 01 Oct 2020 13:50:03 -0400

open5gs (2.0.12~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 01 Oct 2020 13:48:56 -0400

open5gs (2.0.12~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 01 Oct 2020 13:46:28 -0400

open5gs (2.0.11) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 24 Sep 2020 22:06:23 -0400

open5gs (2.0.11~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 24 Sep 2020 22:04:37 -0400

open5gs (2.0.11~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 24 Sep 2020 22:03:26 -0400

open5gs (2.0.10) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 22 Sep 2020 21:25:27 -0400

open5gs (2.0.10~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 22 Sep 2020 21:23:46 -0400

open5gs (2.0.10~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 22 Sep 2020 21:22:40 -0400

open5gs (2.0.9) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 22 Sep 2020 14:08:35 -0400

open5gs (2.0.9~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 22 Sep 2020 14:07:27 -0400

open5gs (2.0.9~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 22 Sep 2020 14:06:05 -0400

open5gs (2.0.8) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 22 Sep 2020 00:49:15 -0400

open5gs (2.0.8~focal2) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 22 Sep 2020 00:48:02 -0400

open5gs (2.0.8~bionic2) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 22 Sep 2020 00:46:46 -0400

open5gs (2.0.7) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 18 Sep 2020 21:51:37 -0400

open5gs (2.0.7~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 18 Sep 2020 21:55:36 -0400

open5gs (2.0.7~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 18 Sep 2020 21:54:21 -0400

open5gs (2.0.6) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 15 Sep 2020 12:37:53 -0400

open5gs (2.0.6~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 15 Sep 2020 12:40:53 -0400

open5gs (2.0.6~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 15 Sep 2020 12:39:41 -0400

open5gs (2.0.5~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 10 Sep 2020 21:59:27 -0400

open5gs (2.0.5~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 10 Sep 2020 21:58:12 -0400

open5gs (2.0.5) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 10 Sep 2020 21:56:16 -0400

open5gs (2.0.4~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Wed, 09 Sep 2020 02:39:43 +0000

open5gs (2.0.4~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Wed, 09 Sep 2020 02:38:39 +0000

open5gs (2.0.4) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Wed, 09 Sep 2020 02:35:55 +0000

open5gs (2.0.3~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 08 Sep 2020 02:40:37 +0000

open5gs (2.0.3~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 08 Sep 2020 02:38:57 +0000

open5gs (2.0.3) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 08 Sep 2020 02:33:07 +0000

open5gs (2.0.2~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sun, 06 Sep 2020 23:59:56 -0400

open5gs (2.0.2~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sun, 06 Sep 2020 23:58:40 -0400

open5gs (2.0.2) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sun, 06 Sep 2020 23:54:34 -0400

open5gs (2.0.1~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sat, 05 Sep 2020 19:39:51 -0400

open5gs (2.0.1~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sat, 05 Sep 2020 19:36:22 -0400

open5gs (2.0.1) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sat, 05 Sep 2020 16:43:24 -0400

open5gs (2.0.0~focal) focal; urgency=medium

  * 5G Core and EPC (Hybrid)

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 21 Aug 2020 23:40:12 -0400



## open5gs 2.0.22

=== subprojects/freeDiameter/CMakeLists.txt ===
# This file is the source for generating the Makefile for the project, using cmake tool (cmake.org)

# Name of the project
PROJECT("freeDiameter")

# Informations to display in daemon's help
SET(FD_PROJECT_NAME freeDiameter)
SET(FD_PROJECT_BINARY freeDiameterd)
SET(FD_PROJECT_COPYRIGHT "Copyright (c) 2008-2015, WIDE Project (www.wide.ad.jp) and NICT (www.nict.go.jp)")

# Version of the source code
SET(FD_PROJECT_VERSION_MAJOR 1)
SET(FD_PROJECT_VERSION_MINOR 3)
SET(FD_PROJECT_VERSION_REV 2)

# Version of the API with the library
SET(FD_PROJECT_VERSION_API 6)

# The test framework, using CTest and CDash.
INCLUDE(CTest)

# CMake version
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

# Location of additional CMake modules
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# The default directories
SET(DEFAULT_CONF_PATH ${CMAKE_INSTALL_PREFIX}/etc/freeDiameter CACHE PATH "Default location of freeDiameter configuration files")

IF (NOT DEFINED LIB_INSTALL_DIR)
SET(LIB_INSTALL_DIR lib CACHE PATH "Default library path name on the system, to accomodate RPM-based systems that use lib64")
ENDIF (NOT DEFINED LIB_INSTALL_DIR)

SET(INSTALL_HEADERS_SUFFIX 		include/freeDiameter 	CACHE PATH "Directory where the headers are installed (relative to CMAKE_INSTALL_PREFIX).")
SET(INSTALL_DAEMON_SUFFIX 		bin 			CACHE PATH "Directory where the daemon binary is installed (relative to CMAKE_INSTALL_PREFIX).")
SET(INSTALL_LIBRARY_SUFFIX 		${LIB_INSTALL_DIR} 			CACHE PATH "Directory where the freeDiameter libraries are installed (relative to CMAKE_INSTALL_PREFIX).")
SET(INSTALL_EXTENSIONS_SUFFIX 	${LIB_INSTALL_DIR}/freeDiameter	CACHE PATH "Directory where the extensions are installed / searched (relative to CMAKE_INSTALL_PREFIX).")

# All source code should be POSIX 200112L compatible, but some other extensions might be used, so:
ADD_DEFINITIONS(-D_GNU_SOURCE)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified.")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo" "Profiling" "MaxPerformance" "DebianPackage" "DebugValgrind")
endif()

# Add a "Profiling" build type
# SET(CMAKE_BUILD_TYPE Profiling)
SET(CMAKE_C_FLAGS_PROFILING "-fprofile-arcs -ftest-coverage -fstack-protector -g -Wall")

# Add a "MaxPerformance" build type -- this is very silent...
# SET(CMAKE_BUILD_TYPE MaxPerformance)
SET(CMAKE_C_FLAGS_MAXPERFORMANCE "${CMAKE_C_FLAGS_RELEASE} -DSTRIP_DEBUG_CODE")

# Add a "DebianPackage" build type used when creating the Debian packages
SET(CMAKE_C_FLAGS_DEBIANPACKAGE "${CMAKE_C_FLAGS_RELWITHDEBINFO}")

# Set the "Debug" flags
SET(CMAKE_C_FLAGS_DEBUG "-Wall -g -O0")

# Add a "DebugValgrind" build type used for checking execution with Valgrind tool
SET(CMAKE_C_FLAGS_DEBUGVALGRIND "-Wall -g -O0")

# Set the DEBUG flag for Debug and Profiling builds
IF (CMAKE_BUILD_TYPE MATCHES "Debug|Profiling|DebugValgrind")
  SET(DEBUG 1)
ENDIF (CMAKE_BUILD_TYPE MATCHES "Debug|Profiling|DebugValgrind")

# some subfolders use yacc and lex parsers
SET(BISON_GENERATE_DEFINES TRUE)
SET(BISON_PREFIX_OUTPUTS TRUE)
INCLUDE(CMakeUserUseBison)
SET(FLEX_PREFIX_OUTPUTS TRUE)
INCLUDE(CMakeUserUseFlex)
IF( NOT BISON_EXECUTABLE OR NOT FLEX_EXECUTABLE )
  MESSAGE( SEND_ERROR "Bison and Flex are required" )
ENDIF( NOT BISON_EXECUTABLE OR NOT FLEX_EXECUTABLE )
# Check that flex is at least 2.5.20 to support bison-bridge
# how to do the check with cmake???

# Add this to workaround an apparent bug in FreeBSD cmake (already defined in Linux)
SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "-rdynamic")

# For Darwin systems
IF(APPLE)
   SET(CMAKE_SHARED_MODULE_CREATE_C_FLAGS "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -flat_namespace -undefined dynamic_lookup")
   SET(CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS "${CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS} -flat_namespace -undefined dynamic_lookup")
ENDIF(APPLE) 

# Location for the include files
INCLUDE_DIRECTORIES(include)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/include)
SUBDIRS(include/freeDiameter)

# Location for the source code
SUBDIRS(libfdproto)
SUBDIRS(libfdcore)
SUBDIRS(freeDiameterd)

# Extensions (there is no use of freeDiameter without any extension)
SUBDIRS(extensions)

# The unary tests directory
IF ( BUILD_TESTING )
	SUBDIRS(tests)
ENDIF ( BUILD_TESTING )

=== subprojects/freeDiameter/extensions/CMakeLists.txt ===
PROJECT("freeDiameter extensions" C)

# We want all resulting objects in the same folder
SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

# Use the macro FD_ADD_EXTENSION(name files...) to create an extension
# It is equivalent to add_library with the appropriate parameters
# and naming conventions (.fdx : FreeDiameter eXtension)
MACRO(FD_ADD_EXTENSION EXTNAME)
  ADD_LIBRARY(${EXTNAME} MODULE ${ARGN})
  SET_TARGET_PROPERTIES(${EXTNAME} PROPERTIES PREFIX "" )
  SET_TARGET_PROPERTIES(${EXTNAME} PROPERTIES SUFFIX ".fdx" )
ENDMACRO(FD_ADD_EXTENSION)

# Use the macro FD_EXTENSION_SUBDIR(extmacroname subdir descr default) to
# add a new extension subdirectory.
MACRO(FD_EXTENSION_SUBDIR EXTSUBDIR EXTDESCR EXTDEFAULT)
   STRING(TOUPPER ${EXTSUBDIR} EXTMACRONAME)
   IF (NOT ALL_EXTENSIONS)
     OPTION(BUILD_${EXTMACRONAME} "Build ${EXTSUBDIR}.fdx? (${EXTDESCR})" ${EXTDEFAULT})
   ENDIF (NOT ALL_EXTENSIONS)
   IF (BUILD_${EXTMACRONAME} OR ALL_EXTENSIONS)
      SUBDIRS(${EXTSUBDIR})
   ENDIF (BUILD_${EXTMACRONAME} OR ALL_EXTENSIONS)
ENDMACRO(FD_EXTENSION_SUBDIR)

OPTION(ALL_EXTENSIONS "Build ALL available extensions? (disable to select individual components)" OFF)

# The extensions include the headers of freeDiameter that contains gnutls objects
INCLUDE_DIRECTORIES(${LFDCORE_INCLUDES})


###########################
# Extensions section

####
# Diameter applications dictionaries

FD_EXTENSION_SUBDIR(dict_nasreq "NASREQ (RFC4005) Dictionary definitions"       ON)
FD_EXTENSION_SUBDIR(dict_eap    "Diameter EAP (RFC4072) Dictionary definitions" ON)

FD_EXTENSION_SUBDIR(dict_dcca         "Diameter CC (RFC4006) Dictionary definitions [incomplete]" ON)
FD_EXTENSION_SUBDIR(dict_dcca_3gpp    "Diameter CC 3GPP Dictionary definitions [incomplete]" ON)
FD_EXTENSION_SUBDIR(dict_dcca_starent "Diameter CC Starent Dictionary definitions" ON)

FD_EXTENSION_SUBDIR(dict_sip    "Diameter SIP (RFC4740) Dictionary definitions" ON)

FD_EXTENSION_SUBDIR(dict_mip6a     "Diameter Mobile IPv6 Auth Dictionary definitions"         ON)
FD_EXTENSION_SUBDIR(dict_mip6i     "Diameter Mobile IPv6 IKE Dictionary definitions"          ON)
FD_EXTENSION_SUBDIR(dict_nas_mipv6 "Diameter NAS-to-HAAA Interaction Dictionary definitions"  ON)
FD_EXTENSION_SUBDIR(dict_rfc5777   "Classification and QoS (RFC 5777) Dictionary definitions" ON)

FD_EXTENSION_SUBDIR(dict_json       "Load Diameter dictionary definitions from JSON files."   OFF)
FD_EXTENSION_SUBDIR(dict_legacy_xml "Load Diameter dictionary definitions from XML files."    OFF)


####
# Diameter applications

FD_EXTENSION_SUBDIR(app_acct    "Simple accounting application that stores accounting records in flat database" OFF)
FD_EXTENSION_SUBDIR(app_diameap "Diameter EAP Application server (RFC 4072)" 					OFF)
FD_EXTENSION_SUBDIR(app_radgw   "RADIUS/Diameter gateway translation - RADIUS client to Diameter server" 	OFF)
FD_EXTENSION_SUBDIR(app_sip     "Diameter SIP Authentication and Authorization server (RFC 4740)" 		OFF)

FD_EXTENSION_SUBDIR(app_redirect "Diameter Redirect server: send configurable Redirect indications to other peers" OFF)


####
# Routing extensions

FD_EXTENSION_SUBDIR(rt_busypeers    "Handling of Diameter TOO_BUSY messages and relay timeouts"	ON)
FD_EXTENSION_SUBDIR(rt_default      "Configurable routing rules for freeDiameter" 		     	ON)
FD_EXTENSION_SUBDIR(rt_deny_by_size "Deny messages that are larger than a configured size" 		     	ON)
FD_EXTENSION_SUBDIR(rt_ereg         "Configurable routing based on regexp matching of AVP values" OFF)
FD_EXTENSION_SUBDIR(rt_ignore_dh    "Stow Destination-Host in Proxy-Info, restore to Origin-Host for answers"	ON)
FD_EXTENSION_SUBDIR(rt_load_balance "Balance load over multiple equal hosts, based on outstanding requests"	ON)
FD_EXTENSION_SUBDIR(rt_randomize    "Randomly choose one of the highest scored hosts and increase its score by one"	ON)
FD_EXTENSION_SUBDIR(rt_redirect     "Handling of Diameter Redirect messages" 			ON)
FD_EXTENSION_SUBDIR(rt_rewrite      "Convert/remove AVP data in messages" 			ON)


####
# Peers security extensions

FD_EXTENSION_SUBDIR(acl_wl "White-list based authorization of incoming connections" ON)


####
# Debug & test extensions

FD_EXTENSION_SUBDIR(dbg_loglevel "Read loglevel from file -- allows runtime change"  ON)
FD_EXTENSION_SUBDIR(dbg_monitor     "Outputs periodical status information"              ON)
FD_EXTENSION_SUBDIR(dbg_msg_timings "Show some timing information for messages"      ON)
FD_EXTENSION_SUBDIR(dbg_msg_dumps   "Show human-readable content of the received & sent messages"      ON)
FD_EXTENSION_SUBDIR(dbg_rt          "Routing extension for debugging the routing module" ON)
FD_EXTENSION_SUBDIR(test_app        "Testing application to send dummy message to another peer, like a Diameter 'ping'" OFF)
FD_EXTENSION_SUBDIR(test_as     "Receive Abort-Session-Requests and display the data" OFF)
FD_EXTENSION_SUBDIR(test_cc     "Receive Credit-Control-Requests and display the data" OFF)
FD_EXTENSION_SUBDIR(test_sip        "Testing application to simulate Diameter-SIP client (RFC4740)" OFF)
FD_EXTENSION_SUBDIR(dbg_interactive "Python-interpreter based module"                OFF)
FD_EXTENSION_SUBDIR(test_netemul    "Simple Diameter network emulator proxy extension (latency, PDV, duplicates)" OFF)



# The following extension have very little use except for specific tests, so we disable them except in Debug configurations.
IF (CMAKE_BUILD_TYPE MATCHES "Debug")
	FD_EXTENSION_SUBDIR(_sample     "Simple extension to demonstrate extension mechanism, for developpers" OFF)
	FD_EXTENSION_SUBDIR(test_acct   "Receive Accounting-Requests and display the data, but no storage" OFF)
	FD_EXTENSION_SUBDIR(test_rt_any "Routing extension randomly sending message to any peer available, for testing purpose" OFF)
ENDIF (CMAKE_BUILD_TYPE MATCHES "Debug")

=== subprojects/freeDiameter/extensions/dict_json/CMakeLists.txt ===
# The dict_json extension
PROJECT("JSON dictionary files support" C)

INCLUDE(FindPkgConfig)

# We use JSONCPP and JSON-Schema to parse and validate JSON files
PKG_CHECK_MODULES(JSONCPP REQUIRED jsoncpp)
PKG_CHECK_MODULES(JSON_SCHEMA REQUIRED json-schema)
PKG_CHECK_MODULES(PCRECPP REQUIRED libpcrecpp)

# List of source files
SET(DICT_JSON_SRC
	dict_json.cc
	${CMAKE_CURRENT_BINARY_DIR}/dict_json_dict_schema.cc
)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
INCLUDE_DIRECTORIES(${JSONCPP_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${JSON_SCHEMA_INCLUDE_DIR})

LINK_DIRECTORIES(${JSONCPP_LIBDIR})
LINK_DIRECTORIES(${JSON_SCHEMA_LIBDIR})

# Compile these files as a freeDiameter extension
FD_ADD_EXTENSION(dict_json ${DICT_JSON_SRC})

TARGET_LINK_LIBRARIES(dict_json ${JSONCPP_LIBRARIES} ${JSON_SCHEMA_STATIC_LIBRARIES})

ADD_EXECUTABLE(dict-json-diff dict-json-diff.cc)
TARGET_LINK_LIBRARIES(dict-json-diff ${JSONCPP_LIBRARIES} ${JSON_SCHEMA_STATIC_LIBRARIES})

ADD_EXECUTABLE(json-schema-to-c json-schema-to-c.cc)
TARGET_LINK_LIBRARIES(json-schema-to-c ${JSONCPP_LIBRARIES} ${JSON_SCHEMA_STATIC_LIBRARIES} ${PCRECPP_LIBRARIES})

ADD_CUSTOM_COMMAND(
	OUTPUT dict_json_dict_schema.cc
	COMMAND json-schema-to-c ${CMAKE_CURRENT_SOURCE_DIR}/dict_json_dict_schema.json ${CMAKE_CURRENT_BINARY_DIR}/dict_json_dict_schema.cc
	DEPENDS dict_json_dict_schema.json
)

####
## INSTALL section ##

INSTALL(TARGETS dict_json
	LIBRARY DESTINATION ${INSTALL_EXTENSIONS_SUFFIX}
	COMPONENT freeDiameter-dictionary-json)
INSTALL(TARGETS dict-json-diff
	RUNTIME DESTINATION ${INSTALL_DAEMON_SUFFIX}
	COMPONENT freeDiameter-dictionary-json)

=== subprojects/freeDiameter/include/freeDiameter/CMakeLists.txt ===
#CMake configuration for freeDiameter include directory

Project("freeDiameter includes directory" C)

########################
# Configurable parameters

# Disable SCTP support completely ?
OPTION(DISABLE_SCTP "Disable SCTP support?" OFF)
IF (NOT DISABLE_SCTP)
	OPTION(DEBUG_SCTP "Verbose SCTP (for debug)?" OFF)
	OPTION(SCTP_USE_MAPPED_ADDRESSES "Use v6-mapped v4 addresses in SCTP (workaround some SCTP limitations)?" OFF)
ENDIF (NOT DISABLE_SCTP)

# Find TODO items in the code easily ?
OPTION(ERRORS_ON_TODO "(development) Generate compilation errors on TODO items ?" OFF)

# In DEBUG mode, each log can contain pid, calling function and file for easy debug. Set to ON to display this information.
OPTION(DEBUG_WITH_META "Show calling location in logs?" OFF)

# Create the absolute path for searching extensions
SET(DEFAULT_EXTENSIONS_PATH ${CMAKE_INSTALL_PREFIX}/${INSTALL_EXTENSIONS_SUFFIX})

# IDNA considerations
OPTION(DIAMID_IDNA_IGNORE "Ignore completely invalid characters in Diameter Identities (process blindly)?" OFF)
IF (NOT DIAMID_IDNA_IGNORE)
	OPTION (DIAMID_IDNA_REJECT "Reject internationalized Diameter Identities, do not attempt to convert it (stringprep) ?" OFF)
ENDIF (NOT DIAMID_IDNA_IGNORE)

# Disable expiration of connections with dynamically connected peers as per RFC 3539 ? (default is enabled)
# Note: if someone needs, we could also make the delay configurable here...
OPTION(DISABLE_PEER_EXPIRY "Disable RFC3539 Peers Connections Expiration after inactivity?" OFF)

# The following workaround increases compatibility with some implementations without breaking anything in freeDiameter,
# so it can be enabled without risk. We keep it disabled by default anyway for those people who use freeDiameter to check the
# compliancy of their implementation with the Diameter RFC...
OPTION(WORKAROUND_ACCEPT_INVALID_VSAI "Do not reject a CER/CEA with a Vendor-Specific-Application-Id AVP containing both Auth- and Acct- application AVPs?" OFF)

MARK_AS_ADVANCED(DISABLE_SCTP DEBUG_SCTP SCTP_USE_MAPPED_ADDRESSES ERRORS_ON_TODO DEBUG_WITH_META DIAMID_IDNA_IGNORE DIAMID_IDNA_REJECT DISABLE_PEER_EXPIRY WORKAROUND_ACCEPT_INVALID_VSAI)

########################
### System checks part

INCLUDE (CheckLibraryExists)
INCLUDE (CheckFunctionExists)
INCLUDE (CheckIncludeFiles)
INCLUDE (CheckSymbolExists)
INCLUDE (CheckCSourceCompiles)
INCLUDE (TestBigEndian)


### System checks -- mandatory support

# We need the getopt_long function
CHECK_FUNCTION_EXISTS (getopt_long HAVE_LONG_OPTIONS)
IF (NOT HAVE_LONG_OPTIONS)
   MESSAGE(SEND_ERROR "The getopt_long function is not found, please add needed library in build system")
ENDIF (NOT HAVE_LONG_OPTIONS)

# getifaddrs ?
CHECK_FUNCTION_EXISTS (getifaddrs HAVE_GETIFADDRS)
IF (NOT HAVE_GETIFADDRS)
   MESSAGE(SEND_ERROR "The getifaddrs function is currently required by freeDiameter.")
ENDIF (NOT HAVE_GETIFADDRS)


### System checks -- for freeDiameter-host.h

# Check byte ordering
TEST_BIG_ENDIAN(HOST_BIG_ENDIAN)

# Check if ntohll is provided on the system
CHECK_SYMBOL_EXISTS(ntohll netinet/in.h HAVE_NTOHLL)

# malloc.h ?
CHECK_INCLUDE_FILES (malloc.h HAVE_MALLOC_H)

# strndup ? Missing on OS X
CHECK_FUNCTION_EXISTS (strndup HAVE_STRNDUP)


### System checks -- for includes / link

# pthreads
INCLUDE(FindThreads)
SET(CMAKE_THREAD_LIBS_INIT ${CMAKE_THREAD_LIBS_INIT} PARENT_SCOPE)

# clock_gettime
SET(HAVE_CLOCK_GETTIME "")
CHECK_FUNCTION_EXISTS (clock_gettime HAVE_NATIVE_CLOCK_GETTIME)
IF (HAVE_NATIVE_CLOCK_GETTIME)
   SET(CLOCK_GETTIME_LIBS "")
   SET(HAVE_CLOCK_GETTIME 1)
ELSE (HAVE_NATIVE_CLOCK_GETTIME)
   CHECK_LIBRARY_EXISTS (rt clock_gettime "" HAVE_LIBRT)
   IF (HAVE_LIBRT)
     SET(CLOCK_GETTIME_LIBS "-lrt")
     SET(HAVE_CLOCK_GETTIME 1)
   ELSE (HAVE_LIBRT)
     CHECK_LIBRARY_EXISTS (posix4 clock_gettime "" HAVE_LIBPOSIX4)
     IF (HAVE_LIBPOSIX4)
       SET(CLOCK_GETTIME_LIBS "-lposix4")
       SET(HAVE_CLOCK_GETTIME 1)
     ENDIF (HAVE_LIBPOSIX4)
   ENDIF (HAVE_LIBRT)
ENDIF (HAVE_NATIVE_CLOCK_GETTIME)
SET(CLOCK_GETTIME_LIBS ${CLOCK_GETTIME_LIBS} PARENT_SCOPE)

# dlopen and dlclose: CMAKE_DL_LIBS

# We need the sctp_connectx function among others
# We need the IPPROTO_SCTP symbol from sys/socket.h, netinet/in.h or netinet/sctp.h
IF(NOT DISABLE_SCTP)
	CHECK_FUNCTION_EXISTS(sctp_connectx HAVE_NATIVE_SCTP)
	IF(NOT HAVE_NATIVE_SCTP)
		FIND_PACKAGE(SCTP REQUIRED)
	ENDIF(NOT HAVE_NATIVE_SCTP)
	# Now check the number of args of this function, since it changed between Ubuntu 9.04 and 9.10
   	SET(CHECK_SCTP_CONNECTX_4_ARGS_SOURCE_CODE "
		#include <unistd.h>
		#include <netinet/sctp.h>
		int main() {
		   return sctp_connectx(0, NULL, 0, NULL);
		}
		")
	SET(CMAKE_REQUIRED_INCLUDES ${SCTP_INCLUDE_DIR})
	SET(CMAKE_REQUIRED_LIBRARIES ${SCTP_LIBRARIES})
	CHECK_C_SOURCE_COMPILES("${CHECK_SCTP_CONNECTX_4_ARGS_SOURCE_CODE}" SCTP_CONNECTX_4_ARGS)
ELSE (NOT DISABLE_SCTP)
	MESSAGE(STATUS "Disabled SCTP support.")
ENDIF(NOT DISABLE_SCTP)
SET(SCTP_INCLUDE_DIR ${SCTP_INCLUDE_DIR} PARENT_SCOPE)
SET(SCTP_LIBRARIES ${SCTP_LIBRARIES} PARENT_SCOPE)

# IDNA process: we use libidn from GNU (unless the function & header files are included in libc)
IF(NOT DIAMID_IDNA_IGNORE AND NOT DIAMID_IDNA_REJECT)
	FIND_PACKAGE(IDNA)
   	SET(CHECK_IDNA_SOURCE_CODE "
		#include <idna.h>
		int main() {
		   return idna_to_ascii_8z(NULL, NULL, 0);
		}
		")
	SET(CMAKE_REQUIRED_INCLUDES ${IDNA_INCLUDE_DIR})
	SET(CMAKE_REQUIRED_LIBRARIES ${IDNA_LIBRARIES})
	CHECK_C_SOURCE_COMPILES("${CHECK_IDNA_SOURCE_CODE}" HAS_IDNA_SUPPORT)
	IF(NOT HAS_IDNA_SUPPORT)
		MESSAGE(SEND_ERROR "Unable to find idna.h header or idna_to_ascii_8z function, please install libidn-dev or equivalent, or set DIAMID_IDNA_IGNORE or DIAMID_IDNA_REJECT")
	ENDIF(NOT HAS_IDNA_SUPPORT)
ELSE (NOT DIAMID_IDNA_IGNORE  AND NOT DIAMID_IDNA_REJECT)
	MESSAGE(STATUS "Non-default Internationalized Domain Names (IDN) behavior selected (no stringprep).")
ENDIF(NOT DIAMID_IDNA_IGNORE  AND NOT DIAMID_IDNA_REJECT)
SET(IDNA_INCLUDE_DIR ${IDNA_INCLUDE_DIR} PARENT_SCOPE)
SET(IDNA_LIBRARIES ${IDNA_LIBRARIES} PARENT_SCOPE)


# Require GNU TLS for building the library
FIND_PACKAGE(GnuTLS REQUIRED)
SET(GNUTLS_INCLUDE_DIR ${GNUTLS_INCLUDE_DIR} PARENT_SCOPE)
SET(GNUTLS_LIBRARIES ${GNUTLS_LIBRARIES} PARENT_SCOPE)

FIND_PATH(GCRYPT_INCLUDE_DIR NAMES gcrypt.h)
IF(NOT GCRYPT_INCLUDE_DIR)
	MESSAGE(SEND_ERROR "Unable to find gcrypt.h, please install libgcrypt-dev or equivalent")
ENDIF(NOT GCRYPT_INCLUDE_DIR)
MARK_AS_ADVANCED(GCRYPT_INCLUDE_DIR)
SET(GCRYPT_INCLUDE_DIR ${GCRYPT_INCLUDE_DIR} PARENT_SCOPE)

# Also we need libgcrypt to... display its version :(
FIND_LIBRARY(GCRYPT_LIBRARY
  NAMES gcrypt
)
IF(NOT GCRYPT_LIBRARY)
	MESSAGE(SEND_ERROR "Unable to find libgcrypt, please install libgcrypt or equivalent")
ENDIF(NOT GCRYPT_LIBRARY)
SET(GCRYPT_LIBRARY ${GCRYPT_LIBRARY} PARENT_SCOPE)


# Check if AI_ADDRCONFIG is available on the system
CHECK_SYMBOL_EXISTS(AI_ADDRCONFIG "netdb.h" HAVE_AI_ADDRCONFIG)


# Check if barriers are available (for test_fifo)
SET(CMAKE_REQUIRED_INCLUDES "pthread.h")
SET(CMAKE_REQUIRED_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
CHECK_FUNCTION_EXISTS (pthread_barrier_wait HAVE_PTHREAD_BAR)
SET(HAVE_PTHREAD_BAR ${HAVE_PTHREAD_BAR} PARENT_SCOPE)


##########################

# Additional hg version when relevant, stored in version.h
if (EXISTS "${CMAKE_SOURCE_DIR}/.hg")
	# Search for hg binary to use
	FIND_PROGRAM(HGCOMMAND hg)
	if (HGCOMMAND)
		# Ok, add the custom target so that hg is executed at every build
		ADD_CUSTOM_TARGET(version_information
				   COMMAND ${CMAKE_COMMAND} -D HGCOMMAND="${HGCOMMAND}" -D SRC="${CMAKE_CURRENT_SOURCE_DIR}/version.h.in" -D DST="${CMAKE_CURRENT_BINARY_DIR}/version.h" -P "${CMAKE_SOURCE_DIR}/cmake/Modules/GetVersionWithHg.cmake"
				   DEPENDS "${CMAKE_SOURCE_DIR}/.hg/dirstate"
				   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
				   COMMENT "Retrieving version of the hg repository"
				   )
	else (HGCOMMAND)
		# Display at least "unknown" rev in this case
		SET(FD_PROJECT_VERSION_HG "unknown")
		CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/version.h.in ${CMAKE_CURRENT_BINARY_DIR}/version.h)
		ADD_CUSTOM_TARGET(version_information DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/version.h)
	endif(HGCOMMAND)
else (EXISTS "${CMAKE_SOURCE_DIR}/.hg")
	# We use the pure version number without extension
	CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/version.h.in ${CMAKE_CURRENT_BINARY_DIR}/version.h)
	ADD_CUSTOM_TARGET(version_information DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/version.h)
endif (EXISTS "${CMAKE_SOURCE_DIR}/.hg")


##########################

# LFDPROTO_LIBS = libraries required by the libfdproto.
SET(LFDPROTO_LIBS ${CLOCK_GETTIME_LIBS} ${CMAKE_THREAD_LIBS_INIT} ${IDNA_LIBRARIES} PARENT_SCOPE)
# And includes paths
SET(LFDPROTO_INCLUDES ${IDNA_INCLUDE_DIR} PARENT_SCOPE)
# Dependencies: the libraries required by any code linking to libfdproto.
SET(LFDPROTO_LINK_INTERFACES ${CMAKE_THREAD_LIBS_INIT} PARENT_SCOPE)

# LFDCORE_LIBS = libraries required by the libfdcore (in addition to libfdproto and its dependencies)
SET(LFDCORE_LIBS ${CLOCK_GETTIME_LIBS} ${CMAKE_DL_LIBS} ${SCTP_LIBRARIES} ${GCRYPT_LIBRARY} ${GNUTLS_LIBRARIES} PARENT_SCOPE)
# And includes paths
SET(LFDCORE_INCLUDES ${SCTP_INCLUDE_DIR} ${GNUTLS_INCLUDE_DIR} ${GCRYPT_INCLUDE_DIR} PARENT_SCOPE)
# And dependencies
SET(LFDCORE_LINK_INTERFACES "" PARENT_SCOPE)
		# We don't force other libraries, the programs will link with what it needs
                # (such as libgnutls if it uses GNUTLS_DEBUG() macro
		# or libfdproto if it uses some of its interfaces directly)
		# See freeDiameterd/CMakeLists.txt for an example.

##########################

# Generate the host.h file
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/freeDiameter-host.h.in ${CMAKE_CURRENT_BINARY_DIR}/freeDiameter-host.h)

####
## INSTALL section ##

# The headers from this directory are required to develop new extensions for freeDiameter.
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/freeDiameter-host.h libfdproto.h libfdcore.h extension.h
	DESTINATION ${INSTALL_HEADERS_SUFFIX}
	COMPONENT freeDiameter-dev)

=== debian/changelog ===
open5gs (2.0.22) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 19 Nov 2020 07:55:27 -0500

open5gs (2.0.22~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 19 Nov 2020 07:54:23 -0500

open5gs (2.0.22~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 19 Nov 2020 07:53:15 -0500

open5gs (2.0.21) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Wed, 11 Nov 2020 14:16:54 -0500

open5gs (2.0.21~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Wed, 11 Nov 2020 14:12:36 -0500

open5gs (2.0.21~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Wed, 11 Nov 2020 14:11:17 -0500

open5gs (2.0.20) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sun, 01 Nov 2020 23:05:14 -0500

open5gs (2.0.20~bionic3) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sun, 01 Nov 2020 23:04:15 -0500

open5gs (2.0.20~focal3) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sun, 01 Nov 2020 23:03:11 -0500

open5gs (2.0.19) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sun, 01 Nov 2020 01:49:04 -0400

open5gs (2.0.19~bionic3) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sun, 01 Nov 2020 01:47:12 -0400

open5gs (2.0.19~focal3) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sun, 01 Nov 2020 01:46:05 -0400

open5gs (2.0.18) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 09 Oct 2020 07:51:09 -0400

open5gs (2.0.18~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 09 Oct 2020 07:48:43 -0400

open5gs (2.0.18~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 09 Oct 2020 07:47:23 -0400

open5gs (2.0.17) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 08 Oct 2020 23:06:11 -0400

open5gs (2.0.17~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 08 Oct 2020 23:05:03 -0400

open5gs (2.0.17~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 08 Oct 2020 23:03:46 -0400

=== debian/control ===
Source: open5gs
Section: net
Priority: optional
Maintainer: Harald Welte <laforge@gnumonks.org>
Uploaders: Sukchan Lee <acetcom@gmail.com>
Build-Depends: debhelper (>= 11),
               git,
               pkg-config,
               meson (>= 0.43.0),
               flex,
               bison,
               libgnutls28-dev,
               libgcrypt-dev,
               libssl-dev,
               libidn11-dev,
               libmongoc-dev,
               libbson-dev,
               libsctp-dev,
               libyaml-dev,
               libmicrohttpd-dev,
               libcurl4-gnutls-dev,
Standards-Version: 4.3.0
Rules-Requires-Root: no
Homepage: https://open5gs.org
Vcs-Browser: https://github.com/open5gs/open5gs
Vcs-Git: git://github.com/open5gs/open5gs

Package: open5gs-common
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${shlibs:Depends},
         ${misc:Depends}
Description: 5G Core and EPC (Shared Files)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package contains some core libraries/plugins required by the other
 binary packages such as open5gs-{mme,sgwc,sgwu,amf,smf,upf,...}.

Package: open5gs-mme
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${shlibs:Depends},
         ${misc:Depends},
         open5gs-common (= ${binary:Version})
Description: MME (Mobility Management Entity)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package provides the MME (Mobility Management Engine), which
 terminates the S1 interfaces from the eNodeBs cells in the cellular
 network, and interfaces via S11 to the SGW-C as well as via S6a to the
 HSS.

Package: open5gs-sgwc
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${shlibs:Depends},
         ${misc:Depends},
         open5gs-common (= ${binary:Version})
Description: SGW-C (Serving Gateway - Control Plane)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package provides the SGW-C (Serving Gateway - Control Plane)
 which is situated between the MME and PGW. It implements the S11 interface
 to the MME, and the S5 interface to the SMF-C.

Package: open5gs-smf
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${shlibs:Depends},
         ${misc:Depends},
         open5gs-common (= ${binary:Version})
Description: SMF (Session Management Function)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package provides the SMF (Session Management Function)

Package: open5gs-amf
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${shlibs:Depends},
         ${misc:Depends},
         open5gs-common (= ${binary:Version})
Description: AMF (Access and Mobility Management Function)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package provides the AMF (Access and Mobility Management Function)

Package: open5gs-sgwu
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${shlibs:Depends},
         ${misc:Depends},
         open5gs-common (= ${binary:Version})
Description: SGW-U (Serving Gateway - User Plane)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package provides the SGW-U (Serving Gateway - User Plane)
 which is situated between the eNB and UPF. It implements the S1U interface
 to the eNB, and the S5U interface to the SMF-U.

Package: open5gs-upf
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${shlibs:Depends},
         ${misc:Depends},
         udev,
         open5gs-common (= ${binary:Version})
Description: UPF (User Plane Function)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package provides the UPF (User Plane Function)

Package: open5gs-hss
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${shlibs:Depends},
         ${misc:Depends},
         mongodb-org | mongodb,
         open5gs-common (= ${binary:Version})
Description: HSS (Home Subscriber Server)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package provides the HSS (Home Subscriber Server) element of the
 EPC, i.e. the central database of mobile network subscribers, with
 their IMSI, MSISDN, cryptographic key materials, service subscription
 information, etc.  It implements the S6a interface towards the MME
 using the DIAMETER protocol.

Package: open5gs-pcrf
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${shlibs:Depends},
         ${misc:Depends},
         mongodb-org | mongodb,
         open5gs-common (= ${binary:Version})
Description: PCRF (Policy and Charging Rules Function)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package contains the PCRF (Policy and Charging Rules Function),
 which controls the service quality (QoS) of individual connections and
 how to account/charge related traffic.  It implements the Gx interface
 towards the SMF-C using the DIAMETER protocol.

Package: open5gs-nrf
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${shlibs:Depends},
         ${misc:Depends},
         open5gs-common (= ${binary:Version})
Description: NRF (Network Repository Function)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package provides the NRF (Network Repository Function)

Package: open5gs-ausf
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${shlibs:Depends},
         ${misc:Depends},
         open5gs-common (= ${binary:Version})
Description: AUSF (Authentication Server Function)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package provides the AUSF (Authentication Server Function)

Package: open5gs-udm
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${shlibs:Depends},
         ${misc:Depends},
         open5gs-common (= ${binary:Version})
Description: UDM (Unified Data Management)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package provides the UDM (Unified Data Managemement)

Package: open5gs-udr
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${shlibs:Depends},
         ${misc:Depends},
         open5gs-common (= ${binary:Version})
Description: UDR (Unified Data Repository)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package provides the UDR (Unified Data Repository)

Package: open5gs
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${misc:Depends},
         open5gs-common (= ${binary:Version}),
         open5gs-mme (= ${binary:Version}),
         open5gs-sgwc (= ${binary:Version}),
         open5gs-smf (= ${binary:Version}),
         open5gs-amf (= ${binary:Version}),
         open5gs-sgwu (= ${binary:Version}),
         open5gs-upf (= ${binary:Version}),
         open5gs-hss (= ${binary:Version}),
         open5gs-pcrf (= ${binary:Version}),
         open5gs-nrf (= ${binary:Version}),
         open5gs-ausf (= ${binary:Version}),
         open5gs-udm (= ${binary:Version}),
         open5gs-udr (= ${binary:Version})
Description: 5G Core and EPC (metapackage)
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This is a metapackage that depends on all the open5gs parts.

Package: open5gs-dbg
Architecture: any
Multi-Arch: same
Depends: osmocom-latest, ${misc:Depends},
         open5gs (= ${binary:Version})
Description: Debug symbols for Open5GS
 Open5GS is a C-language implementation of 5G Core and EPC
 Packet Core, i.e. the core network of an NR/LTE network (Release-16)
 .
 This package contains debug symbols for Open5GS.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export LC_ALL = C.UTF-8

include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=meson

override_dh_install:
	dh_install --sourcedir=obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_test:
	cd obj-$(DEB_HOST_GNU_TYPE) && meson test --suite unit

## open5gs 2.2.1

=== debian/changelog ===
open5gs (2.2.1) unstable; urgency=medium

  * UE IPv6 Support

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 15 Mar 2021 10:06:16 +0900

open5gs (2.2.1~bionic) bionic; urgency=medium

  * UE IPv6 Support

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 15 Mar 2021 10:05:00 +0900

open5gs (2.2.1~focal) focal; urgency=medium

  * UE IPv6 Support

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 15 Mar 2021 10:03:39 +0900

open5gs (2.2.0) unstable; urgency=medium

  * DB Schame Changes

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 08 Mar 2021 21:31:35 +0900

open5gs (2.2.0~bionic) bionic; urgency=medium

  * DB Schame Changes

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 08 Mar 2021 21:30:31 +0900

open5gs (2.2.0~focal) focal; urgency=medium

  * DB Schame Changes

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 08 Mar 2021 21:29:03 +0900

open5gs (2.1.7) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 08 Feb 2021 22:27:23 -0500

open5gs (2.1.7~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 08 Feb 2021 22:26:08 -0500

open5gs (2.1.7~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 08 Feb 2021 22:23:55 -0500

open5gs (2.1.6) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 04 Feb 2021 09:18:13 -0500

open5gs (2.1.6~bionic1) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 04 Feb 2021 09:17:04 -0500

open5gs (2.1.6~focal1) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 04 Feb 2021 09:14:17 -0500

open5gs (2.1.5) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 02 Feb 2021 14:47:59 -0500

open5gs (2.1.5~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 02 Feb 2021 14:46:57 -0500

open5gs (2.1.5~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Tue, 02 Feb 2021 14:45:48 -0500

open5gs (2.1.4) unstable; urgency=medium

  * Paging was added

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 18 Jan 2021 19:14:26 -0500

open5gs (2.1.4~bionic) bionic; urgency=medium

  * Paging was added

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 18 Jan 2021 19:13:26 -0500

open5gs (2.1.4~focal) focal; urgency=medium

  * Paging was added

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 18 Jan 2021 19:12:06 -0500

open5gs (2.1.3) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 08 Jan 2021 23:20:33 -0500

open5gs (2.1.3~bionic1) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 08 Jan 2021 23:19:22 -0500

open5gs (2.1.3~focal1) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 08 Jan 2021 23:17:48 -0500

open5gs (2.1.2) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 08 Jan 2021 00:28:16 -0500

open5gs (2.1.2~bionic1) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 08 Jan 2021 00:27:09 -0500

open5gs (2.1.2~focal1) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 08 Jan 2021 00:25:31 -0500

open5gs (2.1.1) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Wed, 16 Dec 2020 23:04:41 -0500

open5gs (2.1.1~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Wed, 16 Dec 2020 23:03:25 -0500

open5gs (2.1.1~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Wed, 16 Dec 2020 23:02:04 -0500

open5gs (2.1.0) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 11 Dec 2020 14:16:21 -0500

open5gs (2.1.0~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 11 Dec 2020 14:15:00 -0500

open5gs (2.1.0~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 11 Dec 2020 14:13:40 -0500

## open5gs 2.2.2

=== debian/changelog ===
open5gs (2.2.2) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 19 Mar 2021 21:48:13 +0900

open5gs (2.2.2~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 19 Mar 2021 21:47:12 +0900

open5gs (2.2.2~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 19 Mar 2021 21:45:47 +0900

## open5gs 2.2.6

=== debian/changelog ===
open5gs (2.2.6) unstable; urgency=medium

  * HSS Cx Added

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 09 Apr 2021 21:10:43 +0900

open5gs (2.2.6~bionic) bionic; urgency=medium

  * HSS Cx Added

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 09 Apr 2021 21:09:14 +0900

open5gs (2.2.6~focal) focal; urgency=medium

  * HSS Cx Added

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 09 Apr 2021 21:07:19 +0900

open5gs (2.2.5) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sat, 03 Apr 2021 14:16:23 +0900

open5gs (2.2.5~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sat, 03 Apr 2021 14:14:53 +0900

open5gs (2.2.5~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Sat, 03 Apr 2021 14:13:33 +0900

open5gs (2.2.4) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 01 Apr 2021 16:45:22 +0900

open5gs (2.2.4~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 01 Apr 2021 16:43:54 +0900

open5gs (2.2.4~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Thu, 01 Apr 2021 16:42:31 +0900

open5gs (2.2.3) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 29 Mar 2021 22:44:54 +0900

open5gs (2.2.3~bionic) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 29 Mar 2021 22:43:54 +0900

open5gs (2.2.3~focal) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Mon, 29 Mar 2021 22:42:53 +0900

## open5gs 2.2.7

=== debian/changelog ===
open5gs (2.2.7) unstable; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 30 Apr 2021 14:20:47 +0900

open5gs (2.2.7~focal3) focal; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 30 Apr 2021 14:19:39 +0900

open5gs (2.2.7~bionic3) bionic; urgency=medium

  * Bug Fixed

 -- Sukchan Lee <acetcom@gmail.com>  Fri, 30 Apr 2021 14:17:11 +0900

## open5gs 2.2.8

=== debian/changelog ===
open5gs (2.2.8) unstable; urgency=medium

  * Security Protection

 -- Sukchan Lee <acetcom@gmail.com>  Sun, 09 May 2021 11:23:01 +0900

open5gs (2.2.8~bionic) bionic; urgency=medium

  * Security Protection

 -- Sukchan Lee <acetcom@gmail.com>  Sun, 09 May 2021 11:22:02 +0900

open5gs (2.2.8~focal) focal; urgency=medium

  * Security Protection

 -- Sukchan Lee <acetcom@gmail.com>  Sun, 09 May 2021 11:20:13 +0900
